This is an adapted version of the original by Zoong Pham.

--- orig/lib/getaddrinfo.c	2004-03-16 01:26:36
+++ lib/getaddrinfo.c	2004-06-18 17:38:35
@@ -41,6 +41,20 @@
 
 #include <rsync.h>
 
+/****** Start Zoong added here */
+
+#define EAI_BADHINTS	12
+#define EAI_PROTOCOL	13
+#define EAI_MAX	14
+
+#define AI_PASSIVE	0x00000001 /* get address to use bind() */
+#define AI_CANONNAME	0x00000002 /* fill ai_canonname */
+#define AI_NUMERICHOST	0x00000004 /* prevent name resolution */
+#define AI_MASK	(AI_PASSIVE | AI_CANONNAME | AI_NUMERICHOST)
+
+/****** End Zoong added here */
+
+
 #if defined(__KAME__) && defined(INET6)
 # define FAITH
 #endif
--- orig/rsync.h	2004-05-16 07:58:12
+++ rsync.h	2004-07-03 20:23:33
@@ -159,6 +159,11 @@ enum msgcode {
 #include <sys/socket.h>
 #endif
 
+#ifdef HAVE_SYS_UN_H
+#define _SOCKADDR_LEN
+#include <sys/un.h>
+#endif
+
 #ifdef HAVE_STRING_H
 #include <string.h>
 #endif
--- orig/syscall.c	2004-02-18 22:33:21
+++ syscall.c	2004-06-18 17:38:35
@@ -76,6 +76,29 @@ int do_mknod(char *pathname, mode_t mode
 {
 	if (dry_run) return 0;
 	RETURN_ERROR_IF_RO_OR_LO;
+# if HAVE_MKFIFO
+	if (S_ISFIFO(mode))
+		return mkfifo(pathname, mode);
+# endif
+# if HAVE_SYS_UN_H
+	if (S_ISSOCK(mode)) {
+		int sock;
+		struct sockaddr_un saddr;
+		int len = strlen(pathname) + 1; /* include null */
+
+		saddr.sun_family = AF_UNIX;
+		strncpy(saddr.sun_path, pathname, sizeof saddr.sun_path);
+		saddr.sun_len = len > sizeof saddr.sun_path ? sizeof saddr.sun_path: len;
+
+		if ((sock = socket(PF_UNIX, SOCK_STREAM, 0)) < 0)
+			return -1;
+		unlink(pathname);
+		if ((bind(sock, (struct sockaddr*)&saddr, sizeof saddr)) < 0)
+			return -1;
+		close(sock);
+		return do_chmod(pathname, mode);
+	}
+# endif
 	return mknod(pathname, mode, dev);
 }
 #endif
